;
; ROMAjĐp
;

	relaxed on

WIDTH		equ	32	; ioCgPʁj
HEIGHT		equ	120	; c
FLAME		equ	12	; P`悷t[(=Pt[ 1/5bj
PICTNUM		equ	50	; ROM̑S


	org	$4000

	db	"AB"
	dw	START

START:
	di
	ld	sp,$c100

;
; CvO]
;
	ld	hl,MAIN_ST
	ld	de,$c100
	ld	bc,MAIN_ED - MAIN_ST
	ldir

	jp	$c100


MAIN_ST:
	phase	$c100

;
; oNݒ
;
; ǂݏo
; 0x0000-0x7fffFRAM
; 0x8000-0xbfffFROMJ[gbWiBANK#11`#3FFf[^j
; 0xc000-0xffffFRAM
;
; 
; 0x0000-0xffffFRAM

	ld	a,$de
	out	($f1),a
	ld	a,$dd
	out	($f0),a
	ld	a,$55
	out	($f2),a

SYSINIT:
		; VXȅ

	ld	a,$fb
	out	($c0),a		; CSS3-1=011
	ld	a,$f9
	out	($c1),a		; 160x200 OtBbN
	ld	a,$f4
	out	($b0),a		; $0000`\

		; WX^0x07i~LTj̏ʂQrbgݒ肷iBFóAAF́j
	ld	a,$07
	out	($a0),a
	ld	a,$bf
	out	($a1),a

		; WX^0x0eǂݏoݒɂ	
	ld	a,$0e
	out	($a0),a

RESTART:
	ld	b,PICTNUM	; \
	exx

	ld	a,120		; 2b҂
	call	WAITN_VSYNC

	call	GCLR

	ld	a,60		; 1b҂
	call	WAITN_VSYNC

	ld	a,$11-1		; f[^oN̏ݒl|P
	ld	(ROMBANK),a
	call	NEXTBANK

	call	WAIT_flame	; `͈͕҂

MAINLOOP:

	ld	a,$f6		; $4000`\
	ld	de,$0000+(40-WIDTH)/2+(200-HEIGHT)*40/2
	call	DRAWPAGE	; 1/60 x 8 

	ld	a,FLAME-8-1	; 1/60 x (FLAME-8-1) ҂
	call	WAITN_VSYNC

	call	WAIT_flame	; `͈͕҂

	exx
	dec	b
	jp	z,RESTART
	exx


	ld	a,$f4		; $0000`\
	ld	de,$4000+(40-WIDTH)/2+(200-HEIGHT)*40/2
	call	DRAWPAGE	; 1/60 x 8 

	ld	a,FLAME-8-1	; 1/60 x (FLAME-8-1) ҂
	call	WAITN_VSYNC

	call	WAIT_flame	; `͈͕҂

	exx
	dec	b
	jp	z,RESTART
	exx

	jp	MAINLOOP

;
; `͈͕҂
; VSYNC  HL A̕`͈͂I邮炢܂ő҂
;
; VSYNCFHLiC#0j
; `͈́FC#33`#232
;
; C# 0`# 32F912clk@14.32MHz
; C#33`#232F176clk@14.32MHz
;
; vF33x912+200x176 = 65296clk@14.32MHz = 18239clk@4MHz
;
WAIT_flame:
	push	af
	push	bc

	ld	bc,345
.lp1:
	push	bc		; 11+1 / 12
	pop	bc		; 10+1 / 23
	dec	bc		; 6+1  / 30
	ld	a,b		; 4+1  / 35
	or	c		; 4+1  / 40
	jr	nz,.lp1		; 12+1 / 53

	pop	bc
	pop	af
	ret


;
; y[W؊^`
;
DRAWPAGE:
	out	($b0),a		; $0000`/$4000`\

	push	de

	ld	a,HEIGHT
.lp1:
	ex	af,af'		; 4+1		; 5   /   5
	rept	WIDTH
	ldi			; (16+2)*32	; 576 / 581
	endm
	call	po,NEXTBANK	; 10+1		; 11  / 592

	ld	a,40-WIDTH	; 7+1		; 8   / 600
	add	a,e		; 4+1		; 5   / 605
	ld	e,a		; 4+1		; 5   / 610
	ld	a,0		; 7+1		; 8   / 618
	adc	a,d		; 4+1		; 5   / 623
	ld	d,a		; 4+1		; 5   / 628

	ex	af,af'		; 4+1		; 5   / 633
	dec	a		; 4+1		; 5   / 638
	jp	nz,.lp1		; 10+1		; 11  / 649
						; 649*120 = 77880

	ld	a,1
	call	WAITN_VSYNC	; ܂łłSt[

	pop	de
	set	5,d

	ld	a,HEIGHT
.lp2:
	ex	af,af'
	rept	WIDTH
	ldi
	endm
	call	po,NEXTBANK

	ld	a,40-WIDTH
	add	a,e
	ld	e,a
	ld	a,0
	adc	a,d
	ld	d,a

	ex	af,af'
	dec	a
	jp	nz,.lp2

	ld	a,1
	call	WAITN_VSYNC	; ܂łłWt[

	ret

;
; OtBbNʃNA
;
GCLR:
	ld	hl,$0000
	ld	b,0
.clr:
	ld	(hl),b
	inc	hl
	ld	a,h
	cp	$80
	jr	nz,.clr
	ret

;
; HLɂȂ܂ő҂~
; AF
;
WAITN_VSYNC:
.lp1:
	push	af
	call	WAITVSYNC
	pop	af
	dec	a
	jr	nz,.lp1
	ret

;
; HLɂȂ܂ő҂
;
WAITVSYNC:
.lp1:
	in	a,($a2)
	rlca
	jr	nc,.lp1		; HɂȂ܂ő҂
.lp2:
	in	a,($a2)
	rlca
	jr	c,.lp2		; LɂȂ܂ő҂
	ret

;
; ROMJ[gbW̐ݒ
;
NEXTBANK:
	ld	a,(ROMBANK)
	inc	a
	ld	(ROMBANK),a
	out	($34),a		; $8000-$9fff
	ld	hl,$8000
	ld	bc,$2000
	ret

ROMBANK:
	db	$00		; f[^pROMoN

	dephase
MAIN_ED:

	org	$5fff
	db	$ff

end

